###########################################################################
### matorez.tcl								###
### (c) 2003-2005, AzriMan,						###
###									###
### set contacts {							###
###	ICQ	: 1836615; 320630997					###
###	e-mail	: azriman@eggdrop.org.ru				###
###	IRC	: AzriMan@RusNet					###
### }									###
###									###
###       	###
###	.								###
###									###
###########################################################################
### * INTRO:								###
###	     :			###
###	1.  .+user badword (via party-line/dcc)			###
###	2.    ,    - !mat		###
###	3.        	###
###	"source scripts/matorez/matorez.tcl", ..   	###
###	 .  ,   , ..   -	###
###	-  . . : $mat(dict2), $mat(dict),	###
###	 $mat(except).							###
###									###
###									###
###########################################################################
###									###
### * TODO: 1.   , ; 			###
###	NB: (   ,     .	###
###		   -  )				###
###	2.      .		###
###	    .  ,		###
###	,   . ( )			###
###	???        ( )	###
###	   .. ???					###
###	3. #. -  ?????????				###
###	4.     		###
###	-   .. like *!*@host  *!*ident@host	###
###	 *!*@172-16-2-57.somenet.blablabla 			###
###	*!*ident@172-16-*-*.somenet.blablabla.. et cetera, et cetera..	###
###	-   - ..			###
###	5.  listmat, listexcept via msg/dcc,			###
###	. Script History, . 0.4.3 :)					###
###	6.          .	###
###	8.  $dict2      (list + count)	###
###	9.    				###
###									###
###									###
###									###
### *** Script History							###
###									###
### (19.02.2005)							###
### 0.6.4.7								###
###	chan mode +-nopubmat.						###
###									###
### (10.01.2005)							###
### 0.6.4.6								###
###	2 bugs fixed.							###
###									###
### (09.01.2005)							###
### 0.6.4.5								###
###	     .	###
###									###
### (23.11.2004)							###
### 0.6.4.4								###
###	1. 1 bug fixed. Bot answers that "mat detected", when !(botisop)###
###	&& ($lev == "0").						###
###									###
### (11.10.2004)							###
### 0.6.4.3								###
###	1.      switch   .	###
###	2.  ,    0.6.2.4-beta,  	###
###	     , .. $text 		###
###	   .				###
###									###
### (10.10.2004)							###
### 0.6.4.2								###
###	    . / ( 	###
###	 2-      , eggdrop bug)###
###									###
### (09.10.2004)							###
### 0.6.4.1								###
###	1.     "0" (matorez off)  ,###
###	      .		###
###	2.     list(mat/except) ( 	###
###	 ,   $mat(outlen) -  , 	###
###	    . (  ))		###
###	3.    (     )	###
###									###
### (30.05.2004)							###
### 0.6.3-stable -   .   .###
###									###
### (03.04.2004)							###
### 0.6.2.4-beta							###
###	    -1       .		###
###	    -2    dict2.dat,  100% -.	###
###	..      ,  		###
###	       .	###
###	    $contacts   -	###
###	 dict2.dat.							###
###	    -3  fixed 2 bugs,    {			###
###	Tcl error [badw:main]: can't read "time": no such variable	###
###	}  --      - kick.		###
###	    -4     ,     		###
###	   .      	###
###	 . (  )					###
###									###
### (29.03.2004)							###
### 0.6.2.3 -   ,    .	###
###									###
### (12.03.2004)							###
### 0.6.2.2 -  original text;   	###
###									###
### (10.03.2004)							###
### 0.6.2.1 -    ( "b").				###
###									###
### (03.03.2004)							###
### 0.6.2 - !countmat, !countexcept -     .	###
###									###
### (02.03.2004)							###
### 0.6.1.2 - $mat(id_flag) -    .	###
###									###
### (27.02.2004)							###
### 0.6.1 - $mat(nochan) -  ,  ,	###
###	     .				###
###									###
### (25.02.2004)							###
### 0.6.stable-1 -        	###
###	 .     		###
###	been idented, / . ,   	###
###	 .    ""  :)		###
###	 , ,   -    :)	###
###									###
### (11.02.2004)							###
### 0.5.6 -  "addexcept"  "addmat", ..   	###
###	    .   -   .	###
###	  -  .					###
###									###
### (01.02.2004)							###
### 0.5.5 -     ..   	###
###	   .					###
###									###
### (26.01.2004)							###
### 0.5.4 -      .  	###
###	  -     .		###
###									###
### (09.01.2004)							###
### 0.5.3 -    .   	###
###	   ,     .			###
###									###
### (02.01.2004)							###
### 0.5.2 -   . .   - 	###
###	    $mat(dict). ? - mail me, - 	###
###	  - .     -	###
###	        "".	###
###									###
### (27.12.2003)							###
### 0.5.1 -    .   	###
###	 .   , like 3.14, ,		###
###	like 9I, JI, etc..						###
###									###
### (11.12.2003)							###
### 0.5 -    .					###
###									###
### (02.12.2003)							###
### 0.4.3 -   !addmat !addexcept   	###
###	   .      via msg/dcc.	###
###	 .      -	###
###	   .				###
###	!listmat, !listexcept -    ,		###
###	  . , via msg/dcc.			###
###	    dcc,     party line. 		###
###									###
### (16.11.2003)							###
### 0.4.2 -      .			###
###									###
### (04.11.2003)							###
### 0.4.1 -    tolower   .	###
###	 .      	###
###	,,   . . I hope :)			###
###									###
### (02.11.2003)							###
### 0.3.1 -    , underlined, bold, reverse	###
###	   , like "()?/\", etc... 			###
###									###
### (26.10.2003)							###
### 0.3 -           ,	###
###	   						###
###									###
### (17.10.2003)							###
### 0.2.1 - ,   ;)  tolower  		###
###	   .  .			###
###									###
### (15.10.2003)							###
### 0.2 -         ;)	###
###									###
### (14.10.2003)							###
### 0.1 - -    ;)					###
###									###
###########################################################################
###									###
### * :							###
###	1.    .				###
###						(10.11.03)		###
###									###
###	2. C_Jay, LeiDruid    			###
###						(06.12.03)		###
###									###
###	3. Stirlitz, C_Jay, LeiDruid, Dein, PoRNo-MoRoZ,		###
###	  .					###
###						(18.12.03)		###
###									###
###	4. Bart-wht-      .		###
###						(19.12.03)		###
###									###
###	5. aden,  ,   ,  ,		###
###	     .. (, -   -	###
###	   :> )						###
###						(21.01.04)		###
###									###
###	6. RusNet Team,  ,   RusNet ircd,		###
###	    :)),  ,    	###
###	,      IRC  :)		###
###						(23.01.04)		###
###									###
###	7. Tanat,        	###
###						(20.10.04)		###
###									###
###	8. aden@WeNet   ,    	###
###	3-  0.6.2.4 .					###
###						(02.04.04)		###
###									###
###	9. aden@WeNet. history 0.6.4.4.					###
###						(23.11.04)		###
###									###
###	10. leonidas@RusNet.   .				###
###		1.    \001ACTION .			###
###		2.    proc notc:badw:main.			###
###						(09.01.05)		###
###									###
###########################################################################



#########
# BINDS #
#########
bind nick - * nick:badw:main
bind join - * join:badw:main
bind pubm - * pubm:badw:main
bind ctcp - "ACTION" act:badw:main
bind notc - * notc:badw:main
bind pub m|m !mat badw:init
bind pub m|m !addmat badw:addmat:pub
bind pub m|m !addexcept badw:addexcept:pub
bind pub m|m !listmat badw:listmat:pub
bind pub m|m !listexcept badw:listexcept:pub
bind pub m|m !countmat badw:countmat:pub
bind pub m|m !countexcept badw:countexcept:pub


# DCC
bind dcc m addmat badw:addmat:dcc
bind dcc m addexcept badw:addexcept:dcc

# MSG
bind msg m addmat badw:addmat:msg
bind msg m addexcept badw:addexcept:msg



################# MISC #################

### disable matorez on chan wuth selected flag. observe mode off
setudef flag nopubmat

### observe mode on.
setudef flag mat_observe

###   -.
set mat(dict2) "scripts/matorez/dict2.dat"

###    .
set mat(dict) "scripts/matorez/dict.dat"

###   .
set mat(except) "scripts/matorez/except.dat"

### ,    .
set mat(chanlog) "#logchan"

###    : 1 -  ; 2 - .
set mat(say) "1"

### ,    .
set mat(nochan) "#help #helpers #logchan #taganrog #freebsd"

###    .
set mat(id_flag) "D"

###  ,      .
set mat(outlen) "380"

### ,           .
set mat(appendsymb) "1"


set mat(time) "{10} {60} {120}"
set mat(trans) "
	{}
	{   }
	{   + [lindex $mat(time) 0] }
	{   + [lindex $mat(time) 1] }
	{   + [lindex $mat(time) 2] }
"

###        .
### : ("b(B)" -> , ); ("y" -> , .)
set mat(symbtrans) "
	{b 2  }
	{c 2  }
	{h 2  }
	{i 2  }
	{n 2  }
	{p 2  }
	{u 3   }
	{w 2  }
	{y 2  }
"


#set mat(level) "0"
#((10)(20)(30)(40)(50))
#(()()()()())



# encoding system iso8859-1


#    
proc filter {text} {
###	regsub -all {[;:()\[\]!?.,/\\{}]} [tolower $text] "" text;
	regsub -all {[;:<>()\[\]!?.,&~@#$%^_`\"'*+-=/|\\{}]} $text "" text;
	regsub -all {[\x02\x16\x1f]|\x03\d{0,2}(,\d{0,2})?} $text "" text;
#  - 0160
	regsub -all -nocase -- "" $text "" text
#  - ALT+O
	regsub -all -nocase -- "" $text "" text

	return [string trim $text]
}

###


###   .     .
proc dele {text} {
	set text_tmp ""
	set dele_tmp "0"
	set text [split $text {}]
	set num [llength $text]

	for {set ind 0} {$ind < $num} {incr ind} {
		if {([lindex $text $ind] == [lindex $text [expr $ind+1]])} {
			set text [lreplace $text $ind $ind]
			set num [expr $num-1]
			set ind [expr $ind-1]
		}
	}
	
	set text [join $text ""]
	return $text
}


proc tolower {text} { return [string map {                                                                 } [string tolower $text]] }

proc convert {text} {
	### 
	set text [string map {ya  u' } $text]
	### 
	set text [string map {\}|\{  ><  \}\{  \]\[  )(  /\\ } $text]
	### others
	set text [string map {@  9I  9|  91  9l  JI  J|  J1  Jl  /|  \| } $text]
	### 
	set text [string map {3.14  3,14  3  4  6  8  0 } $text]
	return $text
}

proc convert:eng {text} {
	###   
###	set text [string map {a  b  c  d  e  f  g  h  i  k  l  m  n  o  p  q  r  s  t  v  z  u  y  x } $text]
	set text [string map {a  d  e  f  g  j  k  l  m  o  q  r  s  t  v  z  x } $text]
	return $text
}

proc change:eng:rus {text} {
set ch_e_r ""
set not_e ""
	foreach word $text {
		set word [split $word ""]
		foreach symb $word {

			if {($symb >= "a" ) && ($symb <= "z")} {
				continue
			} else {
				set not_e 1
				break
			}
		}
		if {$not_e == "1"} {
			append ch_e_r "[convert:eng $word] "
		} else {
			append ch_e_r "$word "
		}
			
	}
#	set ch_e_r [join $ch_e_r ""]
	return $ch_e_r
}

#   .
proc mat_latcnt {text} {
	set _latcnt "0"
	set text [split $text ""]
	foreach symb $text {
		if {($symb >= "a" ) && ($symb <= "z")} {
			incr _latcnt
		}
	}
return $_latcnt
}

#   ,     .
proc mat_setlat {text} {
	set ind "0"
#	set _setlat $latcnt
	set text [split $text ""]
	foreach symb $text {
		if {($symb >= "a" ) && ($symb <= "z")} {
			append _setlat $ind
		}
		incr ind
	}
	unset ind
set _setlat [split $_setlat ""]
return $_setlat
}

#      .
proc mat_1st_symb_set {text __setlat} {
global mat
#lreplace
#lreplace list first last?element element :?
#.tcl lreplace $qqq 1 2 ff
	set text [split $text ""]
	set ind "0"
	foreach symb $text {
		switch $symb {
			"b" {set text [lreplace $text $ind $ind [lindex [lindex $mat(symbtrans) 0] 2]]}
			"c" {set text [lreplace $text $ind $ind [lindex [lindex $mat(symbtrans) 1] 2]]}
			"h" {set text [lreplace $text $ind $ind [lindex [lindex $mat(symbtrans) 2] 2]]}
			"i" {set text [lreplace $text $ind $ind [lindex [lindex $mat(symbtrans) 3] 2]]}
			"n" {set text [lreplace $text $ind $ind [lindex [lindex $mat(symbtrans) 4] 2]]}
			"p" {set text [lreplace $text $ind $ind [lindex [lindex $mat(symbtrans) 5] 2]]}
			"u" {set text [lreplace $text $ind $ind [lindex [lindex $mat(symbtrans) 6] 2]]}
			"w" {set text [lreplace $text $ind $ind [lindex [lindex $mat(symbtrans) 7] 2]]}
			"y" {set text [lreplace $text $ind $ind [lindex [lindex $mat(symbtrans) 8] 2]]}
		}; #of switch

		incr ind
	}
return [join $text ""]
}


###    .
proc badw:CompleteSearch {text} {

#  .  ???
set latcnt [mat_latcnt $text]

#  ,     .
set setlat [mat_setlat $text]

#     .
set text [mat_1st_symb_set $text $setlat]

#    ..

# hyu
# mat(symbtrans)
#set mat(symbtrans) "
#	{b 2  }
#	{c 2  }
#	{h 2  }
#	{i 2  }
#	{n 2  }
#	{p 2  }
#	{u 3   }
#	{w 2  }
#	{y 2  }
#"


}





################# START OF CHAN COMMANDS #################

proc badw:init {nick uhost hand chan text} {
	if {[channel get $chan nopubmat]} return
	global mat

	if {[mat:ident:check $nick $hand $chan "!mat"] == "0"} {
		return 0
	}
	set stat_s "0"
	set who badword
	set stat [lindex $text 0]
	if {($stat != "low")&&($stat != "med")&&($stat != "hard")&&($stat != "veryhard")&&($stat != "status")&&($stat != "off")} {
		putserv "PRIVMSG $chan :  <status, off, low, med, hard, veryhard>"
		return 0
	}
	set tmp  [lindex [split $chan "#"] 1]
	if {[getuser $who XTRA $tmp] == ""} {
		set stat "info"
		setuser $who XTRA $tmp "0"
		set stat_s "1"
	}
	if {$stat == "status"} {
		set stat "info"
		set stat_s "1"
	}
	if {$stat == "off"} {
		set stat "info"
		setuser $who XTRA $tmp "0"
	}
	if {$stat == "low"} {
		set stat "info"
		setuser  $who XTRA $tmp "1"
	}
	if {$stat == "med"} {
		set stat "info"
		setuser  $who XTRA $tmp "2"
	}
	if {$stat == "hard"} {
		set stat "info"
		setuser  $who XTRA $tmp "3"
	}
	if {$stat == "veryhard"} {
		set stat "info"
		setuser  $who XTRA $tmp "4"
	}
	if {$stat == "info"} {
		set lev [getuser $who XTRA $tmp]
###	       -    "0" (matorez off)
		if {$lev == ""} {
			set lev 0
		}
		if {$stat_s == "1"} {
			putserv "PRIVMSG $chan : [lindex $mat(trans) $lev] "
		} else {
			putserv "PRIVMSG $chan : [lindex $mat(trans) $lev] "
			putserv "PRIVMSG $mat(chanlog) :\002log:\002 \037\037 [lindex $mat(trans) $lev] by $nick!$uhost on $chan"
		}

	}
	###  end of ->> if {$stat == "info"} {..}
}
### end of ->> proc badw:init { .. }

proc nick:badw:main {nick uhost hand chan newnick} {
	if {[channel get $chan nopubmat]} return
	badw:main $nick $uhost $hand $chan $newnick "nick"
}

proc join:badw:main {nick uhost hand chan} {
	if {[channel get $chan nopubmat]} return
	badw:main $nick $uhost $hand $chan $nick "join"
}
proc pubm:badw:main {nick uhost hand chan text} {
	if {[channel get $chan nopubmat]} return
	badw:main $nick $uhost $hand $chan $text "message"
}
proc notc:badw:main {nick uhost hand text dest} {
	if {[channel get $chan nopubmat]} return
	global botnick
	if {($dest == $botnick)} {
		return 0
	}
	badw:main $nick $uhost $hand $dest $text "message"
}
proc act:badw:main {nick uhost hand chan key text} {
	if {[channel get $chan nopubmat]} return
	badw:main $nick $uhost $hand $chan $text "message"
}



##### MAIN #####

proc badw:matcheck {text} {
global mat

###	encoding system
	set text [encoding convertfrom [encoding system] $text]

###	tolower
	set text [tolower $text]
###	putserv "PRIVMSG $mat(chanlog) :tolower == $text"

###	 100% -
	foreach dict2_cur $mat(dict2_ar) {
		if {([string match $dict2_cur $text])} {
			return "1 $dict2_cur $text"
###			break
		}
		#####  end of ->> if {([string match $dict2_cur $text])} { .. }
	}
	#####  end of ->> foreach dict2_cur $mat(dict2_ar) { .. }
###	  --1
	foreach except_cur $mat(except_ar) {
		regsub -all "$except_cur" $text "" text;
	}

###	  
	set text [dele $text]

###	converting symbols
###	putserv "PRIVMSG $mat(chanlog) :conv - [convert $text]"
	set text [convert $text]

###	  
	set text [filter $text]

###	,    $text   
###	set badw_mat 0

###	    ( ,   () .  ())
	set text [change:eng:rus $text]

###	-
	set text [join $text ""]

###	   --2 (  )
	foreach except_cur $mat(except_ar) {
		regsub -all "$except_cur" $text "" text;
	}
#putlog "$text"
#    ,     
	
###	   (go-go-go)
	foreach dict_cur $mat(dict_ar) {
		if {([string match $dict_cur $text])} {
			return "1 $dict_cur $text"
###			break
		}
		#####  end of ->> if {([string match $dict_cur $text])} { .. }
	}
	#####  end of ->> foreach dict_cur $mat(dict_ar) { .. }
return 0
}




proc badw:main {nick uhost hand chan text kind} {
set text_orig $text
global mat


###     
foreach mat_chan_cur $mat(nochan) {
	if {[tolower $chan] == [tolower $mat_chan_cur]} {
		return 0
	}
}

###  
if {[matchattr $hand "b"]} {
	return 0
}


set matcheck_rez [badw:matcheck $text]
###  , 
#putlog "$text"
	if {([lindex $matcheck_rez 0] == "1")} {
#putlog "$text"
		set dict_cur [lindex $matcheck_rez 1]

		switch $kind {
			"message" {set append_riz ""}
			"join" {set append_riz "(mat in join nick)"}
			"nick" {set append_riz "(mat when nick change)"}
		}; #of switch
		set text [lindex $matcheck_rez 2]

		set who "badword"
		set tmp  [lindex [split $chan "#"] 1]
		set lev [getuser $who XTRA $tmp]
###	       -    "0" (matorez off)
		if {$lev == ""} {
			set lev 0
		}	
					
		if {[botisop $chan]} {
			set ipmask [lindex [split [getchanhost $nick $chan] "@"] 0]
			set tmpi [expr [string length $ipmask] - 1]
			if {[string length $ipmask] > 4} {
				set ripmask [string range $ipmask 2 [expr $tmpi - 1]]
			} else {
				set ripmask $ipmask
			}
			set ipmask $ripmask
			unset ripmask
			set temp "*!*"
			append temp $ipmask
			set ipmask [lindex [split [getchanhost $nick $chan] "@"] 1]
			append temp "*@"
			append temp $ipmask
			set ipmask $temp
###	//  .

			if {([matchattr $hand "|M" $chan]) || ([matchattr $hand "M"])} {
				if {$lev == "0"} {return 0}
				putserv "PRIVMSG $chan :\002$nick\002  ,     ...  . $append_riz"
				putserv "PRIVMSG $mat(chanlog) :\002log:\002 \037\037 $append_riz on $chan by $nick!$uhost, but $nick has \"M\".  - $dict_cur. \037text\037 - $text. \037origtext\037 - $text_orig"
				putlog "log: $append_riz on $chan by $nick!$uhost, but $nick has \"M\".  - $dict_cur. \037text\037 - $text. \037origtext\037 - $text_orig"
				return 0
			}
			if {$lev == "0"} {
				return 0
			}
			if {$lev == "1"} {

				putserv "KICK $chan $nick :  . ,  . $append_riz"
				putserv "PRIVMSG $mat(chanlog) :\002log:\002 \037KICK\037 $nick!$uhost on $chan  mat $append_riz.  - $dict_cur. \037text\037 - $text. \037origtext\037 - $text_orig"
				putlog "log: KICK $nick!$uhost on $chan  mat $append_riz.  - $dict_cur. \037text\037 - $text. \037origtext\037 - $text_orig"
				return 0
			}
			if {$lev == "2"} {
				set reason "  . $append_riz"
				set time "[lindex $mat(time) 0]"
				putserv "MODE $chan -o+b $nick $ipmask"
				newchanban $chan $ipmask "badword" $reason $time
				putserv "KICK $chan $nick : . $reason"
			}
			if {$lev == "3"} {
				set reason "   . $append_riz"
				set time "[lindex $mat(time) 1]"
				putserv "MODE $chan -o+b $nick $ipmask"
				newchanban $chan $ipmask "badword" $reason $time
				putserv "KICK $chan $nick : . $reason"
			}
			if {$lev == "4"} {
				set reason ",   . $append_riz"
				set time "[lindex $mat(time) 2]"
				putserv "MODE $chan -o+b $nick $ipmask"
				newchanban $chan $ipmask "badword" $reason $time
				putserv "KICK $chan $nick : . $reason"
			}
			putserv "PRIVMSG $nick :      $append_riz   $chan  $time "
			putserv "PRIVMSG $mat(chanlog) :\002log:\002 \037BAN\037 $nick!$uhost on $chan for mat $append_riz. time: $time.  - $dict_cur. \037text\037 - $text. \037origtext\037 - $text_orig"
			putlog "\002log:\002 \037mat $append_riz\037 detected by $nick!$uhost on $chan. Banned. time: $time.  - $dict_cur. \037text\037 - $text. \037origtext\037 - $text_orig"
			putserv "PRIVMSG $chan :\001ACTION   ...    \001"
		} else {
			if {$lev == "0"} {
				return 0
			} else {
				putserv "PRIVMSG $chan :$nick,     ,    ,  ! $append_riz"
				putserv "PRIVMSG $mat(chanlog) :\002log:\002 \037DO NOTHING\037 (has no op) $nick!$uhost on $chan \037for mat $append_riz\037.  - $dict_cur. \037text\037 - $text. \037origtext\037 - $text_orig"
				putlog "\002log:\002 \037mat $append_riz\037 detected by $nick!$uhost on $chan. Do nothing (has no op).  - $dict_cur. \037text\037 - $text. \037origtext\037 - $text_orig"
			}

		}
		#####  end of ->> if {[botisop $chan]} { .. }

	}
	#####  end of ->> if {($badw_mat == "1")} { .. }
}
#####  end of ->> proc badwrd { .. }




###  , PUB ###
proc badw:addmat:pub {nick uhost hand chan text} {
	if {[channel get $chan nopubmat]} return
	global mat
	if {[mat:ident:check $nick $hand $chan "!addmat"] == "0"} {
		return 0
	}
	if {([lindex $text 0] == "") || ([lindex $text 1] != "")} {
		puthelp "NOTICE $nick :\002Usage:\002 !addmat <mat>"
		return 0
	}
	if {[badw:addmat $hand [lindex $text 0]] == "1"} {
		putserv "[mat:say $nick $chan "$nick, \"[lindex $text 0]\" was successfully added to \"$mat(dict)\" base"]"
	}
}


###  , PUB ###
proc badw:addexcept:pub {nick uhost hand chan text} {
	if {[channel get $chan nopubmat]} return
	global mat
	if {[mat:ident:check $nick $hand $chan "!addexcept"] == "0"} {
		return 0
	}
	if {([lindex $text 0] == "") || ([lindex $text 1] != "")} {
		puthelp "NOTICE $nick :\002Usage:\002 !addexcept <mat>"
		return 0
	}
	if {[badw:addexcept $hand [lindex $text 0]] == "1"} {
		putserv "[mat:say $nick $chan "$nick, \"[lindex $text 0]\" was successfully added to \"$mat(except)\" base"]"
	}
}


### LIST MAT, PUB ###
proc badw:listmat:pub {nick uhost hand chan text} {
	if {[channel get $chan nopubmat]} return
	global mat
	if {[mat:ident:check $nick $hand $chan "!listmat"] == "0"} {
		return 0
	}
	set mat_ind "0"
	putserv "PRIVMSG $nick :Start of mat listing. Total [llength $mat(dict_ar)]."
	set data_answer ""
	foreach mat_element $mat(dict_ar) {
		if { ( [expr [string length $data_answer] + [string length $mat_element]] > $mat(outlen) ) } {
			putserv "PRIVMSG $nick :\002***\002  $data_answer \002***\002"
			set data_answer ""
		}
		append data_answer "$mat_element "
	}
	putserv "PRIVMSG $nick :\002***\002  $data_answer \002***\002"
putserv "PRIVMSG $nick :end of mat listing. Total [llength $mat(dict_ar)]."
unset mat_ind
unset data_answer
}


### LIST EXCEPT, PUB ###
proc badw:listexcept:pub {nick uhost hand chan text} {
	if {[channel get $chan nopubmat]} return
	global mat
	if {[mat:ident:check $nick $hand $chan "!listexcept"] == "0"} {
		return 0
	}
	set except_ind "0"
	putserv "PRIVMSG $nick :Start of except listing. Total [llength $mat(except_ar)]."
	set data_answer ""
	foreach except_element $mat(except_ar) {
		if { ( [expr [string length $data_answer] + [string length $except_element]] > $mat(outlen) ) } {
			putserv "PRIVMSG $nick :\002***\002 $data_answer \002***\002"
			set data_answer ""
		}
		append data_answer "$except_element "
	}
	putserv "PRIVMSG $nick :\002***\002 $data_answer \002***\002"
putserv "PRIVMSG $nick :end of except listing. Total [llength $mat(except_ar)]."
unset except_ind
unset data_answer
}


### COUNT MAT ###
proc badw:countmat:pub {nick uhost hand chan text} {
	if {[channel get $chan nopubmat]} return
	global mat
	if {[mat:ident:check $nick $hand $chan "!countmat"] == "0"} {
		return 0
	}
	putserv "[mat:say $nick $chan "Mat Base. Total: [llength $mat(dict_ar)] elements"]"
}



### COUNT EXCEPT ###
proc badw:countexcept:pub {nick uhost hand chan text} {
	if {[channel get $chan nopubmat]} return
	global mat
	if {[mat:ident:check $nick $hand $chan "!countexcept"] == "0"} {
		return 0
	}
	putserv "[mat:say $nick $chan "Except Base. Total: [llength $mat(except_ar)] elements"]"
}


######## DCC ########

proc badw:addmat:dcc {hand idx text} {
global mat
	if {([lindex $text 0] == "") || ([lindex $text 1] != "")} {
		putdcc $idx "\002Usage:\002 .addmat <mat>"
		return 0
	}
	set nick "dcc"
	set chan "dcc"
	if {[badw:addmat $hand [lindex $text 0]] == "1"} {
		return 1
	}
}


proc badw:addexcept:dcc {hand idx text} {
global mat
	if {([lindex $text 0] == "") || ([lindex $text 1] != "")} {
		putdcc $idx "\002Usage:\002 .addexcept <except>"
		return 0
	}
	set nick "dcc"
	set chan "dcc"
	if {[badw:addexcept $hand [lindex $text 0]] == "1"} {
		return 1
	}
}



######## MSG ########

proc badw:addmat:msg {nick uhost hand text} {
global mat
	if {[llength $text] != 2} {
		putserv "NOTICE $nick :\002Usage:\002 addmat <password> <mat>"
		return 0
	}
	if {![passwdok $hand [lindex $text 0]]} {
		puthelp "PRIVMSG $nick :\037Invalid password\037 \002Usage:\002 addmat <password> <mat>"
		return 0
	}
	if {[badw:addmat $hand [lindex $text 1]] == "1"} {
		putserv "[mat:say $nick $nick "$nick, \"[lindex $text 1]\" was successfully added to \"$mat(dict)\" base"]"
	}
}


proc badw:addexcept:msg {nick uhost hand text} {
global mat
	if {[llength $text] != 2} {
		putserv "NOTICE $nick :\002Usage:\002 addexcept <password> <except>"
		return 0
	}
	if {![passwdok $hand [lindex $text 0]]} {
		puthelp "PRIVMSG $nick :\037Invalid password\037 \002Usage:\002 addexcept <password> <except>"
		return 0
	}
	if {[badw:addexcept $hand [lindex $text 1]] == "1"} {
		putserv "[mat:say $nick $nick "$nick, \"[lindex $text 1]\" was successfully added to \"$mat(except)\" base"]"
	}
}




#####  Initialisation #####


	set mat(except_ar) ""
	set mat(dict_ar) ""
	set mat(dict2_ar) ""

	set except [open $mat(except) r]
	while {[gets $except strexcept] >=0 } {
		regsub -all "$mat(appendsymb)" $strexcept "" strexcept
		append mat(except_ar) "$strexcept "
	}
	close $except

	set dict [open $mat(dict) r]
	while {[gets $dict strdict] >=0 } {
		regsub -all "$mat(appendsymb)" $strdict "" strdict
		append mat(dict_ar) "$strdict "
	}
	close $dict

	set dict2 [open $mat(dict2) r]
	while {[gets $dict2 strdict2] >=0 } {
		regsub -all "$mat(appendsymb)" $strdict2 "" strdict2
		append mat(dict2_ar) "$strdict2 "
	}
	close $dict2


#####  //Initialisation #####





##### MISC #####

proc mat:ident:check {nick hand chan cmd} {
global mat
#	if {![matchattr $hand $mat(id_flag)]} {
#		putserv "[mat:say $nick $chan "$nick, you need to be identified to use \002$cmd\002."]"
#		return 0
#	}
	return 1
}


# usage [mat:say $nick $chan "message"]
proc mat:say {nick chan text} {
global mat
	if {($mat(say) == "1")} {
		return "PRIVMSG $chan :$text"
	}
	if {($mat(say) == "0")} {
		return "NOTICE $nick :$text"
	}
}


proc badw:addmat {hand word} {
global mat
#	set dict [open $mat(dict) w]
#	append mat(dict_ar) "$word "
#	foreach mat_el $mat(dict_ar) {
#		puts $dict $mat_el
#	}
#	putserv "PRIVMSG $mat(chanlog) :\"$word\"     by handle - $hand."
#	putlog "\"$word\"     by handle - $hand."
#	close $dict
#	return 1


	set mat_apn $mat(appendsymb)
	set dict [open $mat(dict) a]
	puts $dict "$word$mat_apn$mat_apn$mat_apn"
	append mat(dict_ar) "$word "
	putserv "PRIVMSG $mat(chanlog) :\"$word\"     by handle - $hand."
	putlog "\"$word\"     by handle - $hand."
	close $dict
	unset mat_apn
	return 1
}


proc badw:addexcept {hand word} {
global mat
#	set except [open $mat(except) w]
#	append mat(except_ar) "$word "
#	foreach exc_el $mat(except_ar) {
#		puts $except $exc_el
#	}
#	putserv "PRIVMSG $mat(chanlog) :\"$word\"     by handle - $hand."
#	putlog "\"$word\"     by handle - $hand."
#	close $except
#	return 1


	set mat_apn $mat(appendsymb)
	set except [open $mat(except) a]
	puts $except "$word$mat_apn$mat_apn$mat_apn"
	append mat(except_ar) "$word "
	putserv "PRIVMSG $mat(chanlog) :\"$word\"     by handle - $hand."
	putlog "\"$word\"     by handle - $hand."
	close $except
	unset mat_apn
	return 1
}


##### //MISC #####





set mat(ver) "0.6.4.7"
putlog "matorez.tcl, ver. $mat(ver) loaded. (c) AzriMan. Counting.. mat:[llength $mat(dict_ar)]+[llength $mat(dict2_ar)]; except:[llength $mat(except_ar)] elements."




###
### proc charfilter (c) ...
###   ..  :)
###
proc charfilter {x {y ""} } {
	for {set i 0} {$i < [string length $x]} {incr i} {
		switch -- [string index $x $i] {
			"\"" {append y "\\\""}
			"\\" {append y "\\\\"}
			"\[" {append y "\\\["}
			"\]" {append y "\\\]"}
			"\} " {append y "\\\} "}
			"\{" {append y "\\\{"}
			default {append y [string index $x $i]}
		}
	}
	return $y
}
